﻿Option Strict On
Option Explicit On

' alle D2D1 Built-in Effekte, entsprechende Parameter und Default-Werte werden hier beschrieben:
' https://docs.microsoft.com/en-us/windows/win32/direct2d/built-in-effects
' Die meisten Effekte können ab Windows 8 und/oder dem "Platform Update for Windows 7" genutzt werden!
' Ein paar Effekte stehen erst ab Windows 10 zur Verfügung. Siehe Doku zu den Built-in Effekten!
' Ich habe hier keine Extrafunktion dafür eingebaut, um zu überprüfen unter welcher Windowsversion dieser Code ausgeführt wird!

Imports System.IO
Imports System.ComponentModel
Imports System.Runtime.InteropServices

Public Class Form1

    Private m_strImageFile0 As String = Path.GetDirectoryName(Application.ExecutablePath) & "\City.jpg"
    Private m_strImageFile1 As String = Path.GetDirectoryName(Application.ExecutablePath) & "\Spider.png"

    Private ReadOnly m_stopWatch As New Stopwatch

    Private m_D2D1Effects As D2D1Effects

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        m_D2D1Effects = New D2D1Effects

        Dim bmpOut As Bitmap = Nothing

        Using bmp As New Bitmap(m_strImageFile0)
            bmpOut = New Bitmap(bmp)
        End Using

        PictureBox1.Image = bmpOut

    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing

        m_D2D1Effects.Dispose()

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Dim pID2D1ImageEffect As IntPtr

        ' Bilder laden und in ein D2D1Image konvertieren
        Dim pID2D1Image0 As IntPtr = m_D2D1Effects.ImageFileToID2D1Image(m_strImageFile0)
        Dim pID2D1Image1 As IntPtr = m_D2D1Effects.ImageFileToID2D1Image(m_strImageFile1)

        ' sind beide D2D1Images vorhanden
        If pID2D1Image0 <> IntPtr.Zero AndAlso pID2D1Image1 <> IntPtr.Zero Then

            ' Wichtig: Immer nur einen Effekt bzw. zusammengesetzte Effekte aktivieren!
            ' Durch Kombination verschiedener Effekte (EffectChain) können weitere Effekte entstehen.
            ' Siehe dazu: https://docs.microsoft.com/en-us/windows/win32/direct2d/how-to-apply-effects-to-primitives

            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1TintEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(1, 0.5, 1, 1))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1CropEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(50, 50, 300, 300))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1TileEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(0, 0, 200, 200))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1YCbCrEffect(pID2D1Image0, pID2D1Image1, New D2D1Effects.D2D1_MATRIX_3X2_F(1, 0, 0, 1, 0, 0))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1AtlasEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(0, 0, 200, 200), New D2D1Effects.D2D1_VECTOR_4F(0, 0, 200, 200))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1BlendEffect(pID2D1Image0, pID2D1Image1)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1FloodEffect(New D2D1Effects.D2D1_VECTOR_4F(1, 0, 0, 1))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1SepiaEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ScaleEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_2F(0.5, 0.5), New D2D1Effects.D2D1_VECTOR_2F(100, 100))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ShadowEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(0, 0, 0, 1), 10)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1BorderEffect(pID2D1Image0, D2D1Effects.D2D1_BORDER_EDGE_MODE.D2D1_BORDER_EDGE_MODE_CLAMP, D2D1Effects.D2D1_BORDER_EDGE_MODE.D2D1_BORDER_EDGE_MODE_CLAMP)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1EmbossEffect(pID2D1Image0, 3, 45)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1InvertEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1SharpenEffect(pID2D1Image0, 2)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1OpacityEffect(pID2D1Image0, 0.5)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ExposureEffect(pID2D1Image0, 0.5)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1VignetteEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(1, 0, 0, 1), 0.2, 1)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ContrastEffect(pID2D1Image0, 0.5)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1RgbToHueEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1HueToRgbEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1CrossFadeEffect(pID2D1Image0, pID2D1Image1, 0.3)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1AlphaMaskEffect(pID2D1Image0, pID2D1Image1)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1PosterizeEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1GrayscaleEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ChromaKeyEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_3F(0, 0, 0), 0.3, False, True)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1CompositeEffect(New IntPtr() {pID2D1Image0, pID2D1Image1}, D2D1Effects.D2D1_COMPOSITE_MODE.D2D1_COMPOSITE_MODE_MASK_INVERT)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1HdrToneMapEffect(pID2D1Image0, 100, 50)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1SaturationEffect(pID2D1Image0, 0.3)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1StraightenEffect(pID2D1Image0, 10, False, D2D1Effects.D2D1_STRAIGHTEN_SCALE_MODE.D2D1_STRAIGHTEN_SCALE_MODE_ANISOTROPIC)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1BrightnessEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_2F(0, 0), New D2D1Effects.D2D1_VECTOR_2F(0.8, 1))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1MorphologyEffect(pID2D1Image0, 5, 5, D2D1Effects.D2D1_MORPHOLOGY_MODE.D2D1_MORPHOLOGY_MODE_DILATE)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(500, 500), New D2D1Effects.D2D1_VECTOR_2F(0.02, 0.02), New D2D1Effects.D2D1_VECTOR_2F(0, 0), D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_TURBULENCE, 1, 0, True)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1PremultiplyEffect(pID2D1Image1)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1HueRotationEffect(pID2D1Image0, 90)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ColorMatrixEffect(pID2D1Image0, New D2D1Effects.D2D1_MATRIX_5X4_F(0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D13DTransformEffect(pID2D1Image0, New D2D1Effects.D2D1_MATRIX_4X4_F(1, 0.2, 0, 0, 0.2, 1, 0, 0, 0, 0, 1, 0, 20, 20, 20, 1))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1GaussianBlurEffect(pID2D1Image0, 3, D2D1Effects.D2D1_GAUSSIANBLUR_OPTIMIZATION.D2D1_GAUSSIANBLUR_OPTIMIZATION_BALANCED, D2D1Effects.D2D1_BORDER_MODE.D2D1_BORDER_MODE_HARD)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1LookupTable3DEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1EdgeDetectionEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1TableTransferEffect(pID2D1Image0, New Single() {1, 0.75, 0.5, 0.25, 0}, New Single() {1, 0, 1}, New Single() {0, 0.25, 0.5, 0.75, 1})
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1GammaTransferEffect(pID2D1Image0, 1, 0.25, 0, 1, 0.25, 0, 1, 0.25, 0, 1, 0.25, 0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1UnPremultiplyEffect(pID2D1Image1)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ColorManagementEffect(pID2D1Image0, D2D1Effects.D2D1_COLOR_SPACE.D2D1_COLOR_SPACE_SCRGB, D2D1Effects.D2D1_COLORMANAGEMENT_RENDERING_INTENT.D2D1_COLORMANAGEMENT_RENDERING_INTENT_SATURATION, D2D1Effects.D2D1_COLOR_SPACE.D2D1_COLOR_SPACE_SRGB, D2D1Effects.D2D1_COLORMANAGEMENT_RENDERING_INTENT.D2D1_COLORMANAGEMENT_RENDERING_INTENT_ABSOLUTE_COLORIMETRIC)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1OpacityMetadataEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(0, 0, 200, 200))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1LinearTransferEffect(pID2D1Image0, -1, -1, -1, 1, 3, 2, 3, 1)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ConvolveMatrixEffect(pID2D1Image0, New Single() {-1, -1, -1, -1, 9, -1, -1, -1, -1}, New D2D1Effects.D2D1_VECTOR_2F(0, 0), New D2D1Effects.D2D1_VECTOR_2F(1, 1), 0.5, -0.5)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1DpiCompensationEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_2F(125, 125))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1DirectionalBlurEffect(pID2D1Image0, 3, 45, D2D1Effects.D2D1_BORDER_MODE.D2D1_BORDER_MODE_HARD)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1TemperatureTintEffect(pID2D1Image0, 0.5, -0.1)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1DiscreteTransferEffect(pID2D1Image0, New Single() {1, 0.75, 0.5, 0.25, 0}, New Single() {1, 0, 1}, New Single() {0, 0.25, 0.5, 0.75, 1})
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1LuminanceToAlphaEffect(pID2D1Image0)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1HighlightsShadowsEffect(pID2D1Image0, 0, 0.5, 0.2)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D12DAffineTransformEffect(pID2D1Image0, New D2D1Effects.D2D1_MATRIX_3X2_F(0.9, -0.1, 0.1, 0.9, 50, 70), 1, D2D1Effects.D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE.D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_ANISOTROPIC)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ArithmeticCompositeEffect(pID2D1Image0, pID2D1Image1, New D2D1Effects.D2D1_VECTOR_4F(0.5, 0.5, 1, -0.5))
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D1WhiteLevelAdjustmentEffect(pID2D1Image0, 80, 50)
            'pID2D1ImageEffect = m_D2D1Effects.CreateD2D13DPerspectiveTransformEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_2F(0, 0), New D2D1Effects.D2D1_VECTOR_3F(-80, 200, 0), New D2D1Effects.D2D1_VECTOR_3F(0, 0, 0), New D2D1Effects.D2D1_VECTOR_3F(0, 0, 0), New D2D1Effects.D2D1_VECTOR_3F(-20, -15, -20), 200, D2D1Effects.D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE.D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_ANISOTROPIC, D2D1Effects.D2D1_BORDER_MODE.D2D1_BORDER_MODE_SOFT)


            ' ----==== zusammengesetzte Effekte ====----
            Dim pTurbolence As IntPtr = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(1000, 1000),
                                                                                 New D2D1Effects.D2D1_VECTOR_2F(0.03, 0.03),
                                                                                 New D2D1Effects.D2D1_VECTOR_2F(0, 0),
                                                                                 D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_TURBULENCE,
                                                                                 1, 0, True)
            If pTurbolence <> IntPtr.Zero Then

                pID2D1ImageEffect = m_D2D1Effects.CreateD2D1DisplacementMapEffect(pID2D1Image0, pTurbolence, 100)

                Marshal.Release(pTurbolence)
            End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            'Dim pTurbolence As IntPtr = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(500, 500),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0.02, 0.02),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0, 0),
            '                                                                     D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_TURBULENCE,
            '                                                                     2, 0, True)
            'If pTurbolence <> IntPtr.Zero Then

            '    pID2D1ImageEffect = m_D2D1Effects.CreateD2D1SpotDiffuseEffect(pTurbolence,
            '                                                                  New D2D1Effects.D2D1_VECTOR_3F(0.5, 0.5, 0.5),
            '                                                                  New D2D1Effects.D2D1_VECTOR_3F(450, 450, 2),
            '                                                                  New D2D1Effects.D2D1_VECTOR_2F(1, 1),
            '                                                                  New D2D1Effects.D2D1_VECTOR_3F(1, 1, 1),
            '                                                                  20, 90, 30, 1)

            '    Marshal.Release(pTurbolence)
            'End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            'Dim pTurbolence As IntPtr = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(500, 500),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0.02, 0.02),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0, 0),
            '                                                                     D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_TURBULENCE,
            '                                                                     2, 0, True)
            'If pTurbolence <> IntPtr.Zero Then

            '    pID2D1ImageEffect = m_D2D1Effects.CreateD2D1SpotSpecularEffect(pTurbolence,
            '                                                                   New D2D1Effects.D2D1_VECTOR_3F(1, 0.2, 0.5),
            '                                                                   New D2D1Effects.D2D1_VECTOR_3F(450, 450, 2),
            '                                                                   New D2D1Effects.D2D1_VECTOR_2F(1, 1),
            '                                                                   New D2D1Effects.D2D1_VECTOR_3F(1, 1, 1),
            '                                                                   20, 90, 10, 30, 1)

            '    Marshal.Release(pTurbolence)
            'End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            'Dim pTurbolence As IntPtr = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(500, 500),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0.02, 0.02),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0, 0),
            '                                                                     D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_TURBULENCE,
            '                                                                     2, 0, True)
            'If pTurbolence <> IntPtr.Zero Then

            '    pID2D1ImageEffect = m_D2D1Effects.CreateD2D1PointDiffuseEffect(pTurbolence,
            '                                                                   New D2D1Effects.D2D1_VECTOR_3F(0.5, 0.5, 0),
            '                                                                   New D2D1Effects.D2D1_VECTOR_3F(250, 250, 0.1),
            '                                                                   New D2D1Effects.D2D1_VECTOR_2F(1, 1),
            '                                                                   30, 1)

            '    Marshal.Release(pTurbolence)
            'End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            'Dim pTurbolence As IntPtr = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(500, 500),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0.02, 0.02),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0, 0),
            '                                                                     D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_TURBULENCE,
            '                                                                     2, 0, True)
            'If pTurbolence <> IntPtr.Zero Then

            '    pID2D1ImageEffect = m_D2D1Effects.CreateD2D1PointSpecularEffect(pTurbolence,
            '                                                                    New D2D1Effects.D2D1_VECTOR_3F(1, 0, 0),
            '                                                                    New D2D1Effects.D2D1_VECTOR_3F(250, 250, 0.1),
            '                                                                    New D2D1Effects.D2D1_VECTOR_2F(1, 1),
            '                                                                    10, 10, 2)

            '    Marshal.Release(pTurbolence)
            'End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            'Dim pTurbolence As IntPtr = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(500, 500),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0.02, 0.02),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0, 0),
            '                                                                     D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_FRACTAL_SUM,
            '                                                                     5, 0, True)
            'If pTurbolence <> IntPtr.Zero Then

            '    pID2D1ImageEffect = m_D2D1Effects.CreateD2D1DistantDiffuseEffect(pTurbolence,
            '                                                                     New D2D1Effects.D2D1_VECTOR_3F(1, 2, 2),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(1, 1),
            '                                                                     45, 2, 5, 3)

            '    Marshal.Release(pTurbolence)
            'End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            'Dim pTurbolence As IntPtr = m_D2D1Effects.CreateD2D1TurbulenceEffect(New D2D1Effects.D2D1_VECTOR_2F(500, 500),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0.02, 0.02),
            '                                                                     New D2D1Effects.D2D1_VECTOR_2F(0, 0),
            '                                                                     D2D1Effects.D2D1_TURBULENCE_NOISE.D2D1_TURBULENCE_NOISE_FRACTAL_SUM,
            '                                                                     5, 0, True)
            'If pTurbolence <> IntPtr.Zero Then

            '    pID2D1ImageEffect = m_D2D1Effects.CreateD2D1DistantSpecularEffect(pTurbolence, New D2D1Effects.D2D1_VECTOR_3F(1, 1, 1),
            '                                                                      New D2D1Effects.D2D1_VECTOR_2F(1, 1), 45, 2, 1, 1, 10)

            '    Marshal.Release(pTurbolence)
            'End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            ' ShadowEffekt vom Bild erstellen
            'Dim pShadow = m_D2D1Effects.CreateD2D1ShadowEffect(pID2D1Image0, New D2D1Effects.D2D1_VECTOR_4F(0.2, 0.2, 0.2, 1), 7)
            'If pShadow <> IntPtr.Zero Then

            '    ' Bild vom ShadowEffekt um 12 Pixel nach unten und rechts verschieben
            '    Dim p2DAffineTransform = m_D2D1Effects.CreateD2D12DAffineTransformEffect(pShadow, New D2D1Effects.D2D1_MATRIX_3X2_F(1, 0, 0, 1, 12, 12))
            '    If p2DAffineTransform <> IntPtr.Zero Then

            '        ' Bild vom ShadowEffekt und Bild übereinander zeichnen.
            '        ' Beim D2D1CompositeEffect werden die Bilder in der Reihenfolge übereinander gezeichnet,
            '        ' wie sie im Array angegeben werden! Mindestens 2 Bilder müssen vorhanden sein!
            '        pID2D1ImageEffect = m_D2D1Effects.CreateD2D1CompositeEffect(New IntPtr() {p2DAffineTransform, pID2D1Image0})

            '        Marshal.Release(p2DAffineTransform)
            '    End If
            '    Marshal.Release(pShadow)
            'End If
            ' ----==================================----


            ' ----==== zusammengesetzte Effekte ====----
            'Dim pBlur As IntPtr = m_D2D1Effects.CreateD2D1GaussianBlurEffect(pID2D1Image0, 50)
            'If pBlur <> IntPtr.Zero Then

            '    Dim pSpotSpecular As IntPtr = m_D2D1Effects.CreateD2D1SpotSpecularEffect(pBlur,
            '                                                                             New D2D1Effects.D2D1_VECTOR_3F(0.5, 0.5, 0),
            '                                                                             New D2D1Effects.D2D1_VECTOR_3F(500, 375, 5),
            '                                                                             New D2D1Effects.D2D1_VECTOR_2F(1, 1),
            '                                                                             New D2D1Effects.D2D1_VECTOR_3F(1, 1, 1),
            '                                                                             10, 90, 10, 30, 1)
            '    If pSpotSpecular <> IntPtr.Zero Then

            '        Dim pComposite As IntPtr = m_D2D1Effects.CreateD2D1CompositeEffect(pID2D1Image0,
            '                                                                           pSpotSpecular,
            '                                                                           D2D1Effects.D2D1_COMPOSITE_MODE.D2D1_COMPOSITE_MODE_SOURCE_IN)
            '        If pComposite <> IntPtr.Zero Then

            '            pID2D1ImageEffect = m_D2D1Effects.CreateD2D1ArithmeticCompositeEffect(pID2D1Image0,
            '                                                                                  pComposite,
            '                                                                                  New D2D1Effects.D2D1_VECTOR_4F(0, 1, 1, 0))

            '            Marshal.Release(pComposite)

            '        End If

            '        Marshal.Release(pSpotSpecular)

            '    End If

            '    Marshal.Release(pBlur)

            'End If
            ' ----=============================================----


            ' ist ein durch ein Effekt vorhandenes D2D1Image vorhanden
            If pID2D1ImageEffect <> IntPtr.Zero Then

                Debug.Print("D2D1-Effekt Ok")

                ' D2D1Image in ein .Net-Bitmap konvertieren
                PictureBox1.Image = m_D2D1Effects.ID2D1ImageToBitmap(pID2D1ImageEffect)

                ' D2D1Image löschen
                Marshal.Release(pID2D1ImageEffect)

            Else

                ' ansonsten D2D1Image ohne Effekt anzeigen
                PictureBox1.Image = m_D2D1Effects.ID2D1ImageToBitmap(pID2D1Image0)

            End If

            ' D2D1Images löschen
            Marshal.Release(pID2D1Image1)
            Marshal.Release(pID2D1Image0)

        End If

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"


    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Dim pIWICBitmap As IntPtr = m_D2D1Effects.ImageFileToIWICBitmap(m_strImageFile0)

        If pIWICBitmap <> IntPtr.Zero Then

            PictureBox1.Image = m_D2D1Effects.IWICBitmapToBitmap(pIWICBitmap)

            Marshal.Release(pIWICBitmap)

        End If

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Dim pID2D1Image As IntPtr = m_D2D1Effects.ImageFileToID2D1Image(m_strImageFile0)

        If pID2D1Image <> IntPtr.Zero Then

            PictureBox1.Image = m_D2D1Effects.ID2D1ImageToBitmap(pID2D1Image)

            Marshal.Release(pID2D1Image)

        End If

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"

    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Dim pIWICBitmap As IntPtr = m_D2D1Effects.ImageFileToIWICBitmap(m_strImageFile0)

        If pIWICBitmap <> IntPtr.Zero Then

            Dim pID2D1Image As IntPtr = m_D2D1Effects.CreateD2D1BitmapSourceEffect(pIWICBitmap)

            If pID2D1Image <> IntPtr.Zero Then

                PictureBox1.Image = m_D2D1Effects.ID2D1ImageToBitmap(pID2D1Image)

                Marshal.Release(pID2D1Image)

            End If

            Marshal.Release(pIWICBitmap)

        End If

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"

    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Dim bmpOut As Bitmap = Nothing

        Using bmp As New Bitmap(m_strImageFile0)
            bmpOut = New Bitmap(bmp)
        End Using

        PictureBox1.Image = bmpOut

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"

    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Using bmp As New Bitmap(m_strImageFile1)

            ' Bitmap.GetHbitmap kann nicht mit dem Pixelformat PARGB umgehen!!!
            ' Das ist ein GDI+ Bug!!! Erzeugt das gleiche wie der D2D1UnPremultiplyEffect!
            ' bessere Alternative: siehe Button7
            Dim pIWICBitmap As IntPtr = m_D2D1Effects.BitmapToIWICBitmap(bmp.GetHbitmap)

            If pIWICBitmap <> IntPtr.Zero Then

                PictureBox1.Image = m_D2D1Effects.IWICBitmapToBitmap(pIWICBitmap)

                Marshal.Release(pIWICBitmap)

            End If

        End Using

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"

    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Using bmp As New Bitmap(m_strImageFile1)

            Dim pIWICBitmap As IntPtr = m_D2D1Effects.BitmapToIWICBitmap(bmp)

            If pIWICBitmap <> IntPtr.Zero Then

                PictureBox1.Image = m_D2D1Effects.IWICBitmapToBitmap(pIWICBitmap)

                Marshal.Release(pIWICBitmap)

            End If

        End Using

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"

    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click

        If PictureBox1.Image IsNot Nothing Then PictureBox1.Image.Dispose()

        Dim intHistogramDataSize As Integer
        Dim sngHistogramData As Single() = New Single() {}
        Dim sngMaxValue As Single
        Dim colChannel As Color
        Dim eChannel As D2D1Effects.D2D1_CHANNEL_SELECTOR = D2D1Effects.D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_R

        m_stopWatch.Reset()
        m_stopWatch.Start()

        Dim pID2D1Image As IntPtr = m_D2D1Effects.ImageFileToID2D1Image(m_strImageFile0)

        If pID2D1Image <> IntPtr.Zero Then

            If m_D2D1Effects.CreateD2D1HistogramEffect(pID2D1Image, intHistogramDataSize, sngHistogramData, eChannel) Then

                If intHistogramDataSize > 0 Then

                    Dim bmpHistogram As New Bitmap(256 * 2, 256, Imaging.PixelFormat.Format24bppRgb)

                    Using gra As Graphics = Graphics.FromImage(bmpHistogram)

                        Select Case eChannel
                            Case D2D1Effects.D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_A
                                colChannel = Color.Gray
                            Case D2D1Effects.D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_R
                                colChannel = Color.Red
                            Case D2D1Effects.D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_G
                                colChannel = Color.Green
                            Case D2D1Effects.D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_B
                                colChannel = Color.Blue
                        End Select

                        For intItem = 0 To intHistogramDataSize - 1

                            If sngHistogramData(intItem) > sngMaxValue Then sngMaxValue = sngHistogramData(intItem)

                        Next

                        Using pen = New Pen(colChannel, 2)

                            For intItem = 0 To intHistogramDataSize - 1

                                gra.DrawLine(pen, intItem * 2, bmpHistogram.Height - (((sngHistogramData(intItem) * bmpHistogram.Height) / sngMaxValue)), intItem * 2, bmpHistogram.Height)

                            Next

                        End Using

                    End Using

                    PictureBox1.Image = bmpHistogram

                End If

            End If

            Marshal.Release(pID2D1Image)

        End If

        m_stopWatch.Stop()
        Me.Text = m_stopWatch.Elapsed.TotalMilliseconds.ToString & "ms"

    End Sub
End Class
